﻿#include <algorithm>
#include <climits>
#include <cmath>
#include <deque>
#include <iostream>
#include <set>
#include <tuple>
#include <queue>

#define int long long
#define INF INT_MAX
#define opt ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

using namespace std;

int32_t main() {
    opt;
    int n, m, k;
    cin >> n >> m >> k;
    deque<tuple<int, int>> e(m);
    for (int i = 0; i < m; ++i) {
        cin >> get<0>(e[i]) >> get<1>(e[i]);
        get<0>(e[i])--;
        get<1>(e[i])--;
    }

    deque<pair<int, int>> g(k);
    for (int i = 0; i < k; ++i) {
        cin >> g[i].first >> g[i].second;
        g[i].first--;
    }

    deque<bool> p(n, false);

    for (int i = 0; i < k; ++i) {
        int w = g[i].first;
        int r = g[i].second;

        queue<pair<int, int>> q;
        q.push({ w, 0 });
        deque<bool> v(n, false);
        v[w] = true;

        while (!q.empty()) {
            int u = q.front().first;
            int d = q.front().second;
            q.pop();

            if (d <= r)
                p[u] = true;
            if (d >= r)
                continue;

            for (const auto& j : e) {
                int x = -1;
                if (get<0>(j) == u && !v[get<1>(j)])
                    x = get<1>(j);
                else if (get<1>(j) == u && !v[get<0>(j)])
                    x = get<0>(j);
                if (x != -1) {
                    q.push({ x, d + 1 });
                    v[x] = true;
                }
            }
        }
    }
    deque<int> answer;
    for (int i = 0; i < n; ++i) {
        if (p[i]) {
            answer.push_back(i + 1);
        }
    }
    cout << answer.size() << "\n";
    for (auto& i : answer)
    {
        cout << i << " ";
    }
}